﻿

var bc_ext_instance = null;

var bc_ext = {

	onLoad: function() 
	{
		// initialization code
		this.initialized = true;
		this.strings = document.getElementById("bc_ext-strings");
		document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", onContentPopupMenu, false);
		        
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		bc_ext_instance = Components.classes["@bitcomet.com/BitCometExtension;1"].createInstance( Components.interfaces.IBitCometExtension );
		if( !bc_ext_instance )
		{
			window.alert( "Failed BitCometExtension, No Class." );
		}
	},

	showContextMenu: function(event) 
	{ 
		var bc_menu_download_link_item = document.getElementById("bc_menu_download_link_item");
		if (bc_menu_download_link_item)
		{
			const isOnLink = gContextMenu.onSaveableLink || (gContextMenu.inDirList && gContextMenu.onLink);
			bc_menu_download_link_item.hidden = !isOnLink;
		}
		
		var bc_menu_download_all_item = document.getElementById("bc_menu_download_all_item");
		if (bc_menu_download_all_item)
		{
			var cur_wnd = document.commandDispatcher.focusedWindow.top;
			var cur_doc = cur_wnd.document;
			bc_menu_download_all_item.hidden = cur_doc.links.length < 1;
		}
		
		var no_menu = bc_menu_download_link_item.hidden && bc_menu_download_all_item.hidden;
		if ( no_menu )
		{
			var mi_seperator = document.getElementById("bc_menu_seperator_1");
			if (mi_seperator)
				mi_seperator.hidden = true;
		}
	},
	
	onCmdDownloadSingleLink: function(e) 
	{            
		try
		{
			var cur_wnd = document.commandDispatcher.focusedWindow.top;
			var cur_doc = cur_wnd.document;
			var ref_url = cur_doc.URL;
			if (null == ref_url)
				return;
			
			var page_title = cur_doc.title;
			if (null == page_title)
				page_title = '';
			
			var arr_link = new Array();
			var link_url = gContextMenu.link;
			if (null == link_url)
				return;
			arr_link.push(link_url);
			
			var str_coment = this.extractDescription(gContextMenu.target);
			if ( str_coment == '' && gContextMenu.target.parentNode != null )
				str_coment = this.extractDescription(gContextMenu.target.parentNode);
			
			arr_link.push(str_coment);
			
			bc_ext_instance.Download(arr_link.length, arr_link, ref_url, page_title, '');
		}
		catch(e)
		{
			window.alert( "BitCometExtension Failed, " + e.message );
		}
	},

	onCmdDownloadAll: function(e) 
	{
		try
		{
			var cur_wnd = document.commandDispatcher.focusedWindow.top;
			var cur_doc = cur_wnd.document;
			var ref_url = cur_doc.URL;
			if (null == ref_url)
				return;
			
			var page_title = cur_doc.title;
			if (null == page_title)
				page_title = '';
			
			if (cur_doc.links.length < 1)
				return;
			
			var arr_link = new Array();
			var link_url = '';
			var str_coment = '';
			
			for (var i=0; i<cur_doc.links.length; ++i)
			{
				link_url = cur_doc.links[i].href;
				if (null == link_url)
					continue;
				
				str_coment = this.extractDescription(cur_doc.links[i]);
				
				arr_link.push(link_url);
				arr_link.push(str_coment);
			}
			
			if (arr_link.length < 1)
				return;
			
			bc_ext_instance.Download(arr_link.length, arr_link, ref_url, page_title, '');
		}
		catch(e)
		{
			window.alert( "BitCometExtension Failed, " + e.message );
		}
	},
	
	trim : function(t)
	{
		return t.replace(/^[ \t_]+|[ \t_]+$/gi, "").replace(/(_){2,}/g, "_");
	},
	
	fmt : function(s)
	{
		return s.replace(/(\n){1,}/gi, " ").replace(/(\s){2,}/gi, " ");
	},

	extractDescription : function(child)
	{
		var rv = "";
		
		if ( rv == "" && child.nodeValue && child.nodeValue != "")
		{
			rv = this.fmt( child.nodeValue );
		}

		if ( rv == "" && child.hasAttribute )
		{
			if (child.hasAttribute('title'))
			{
				rv = this.fmt( child.getAttribute('title') );
			}
			else if (child.hasAttribute('alt'))
			{
				rv = this.fmt( child.getAttribute('alt') );
			}
		}

		if ( rv == "" && child.nodeType == 1)
		{
			for (var i = 0, len = child.childNodes.length; i < len && rv == ''; ++i)
			{
				rv = this.extractDescription( child.childNodes[i] );
			}
		}
		return this.trim(rv);
	}
  
	/*getVersion: function()
	{
		try
		{
			if (null == bc_ext_instance)
				return;
	
			var	value =	{value:	0};
	
			bc_ext_instance.GetInfo("version", value);
			window.alert( value.value );
			return parseFloat( value.value );
	
		}
		catch (e)
		{
			window.alert( "BitCometExtension Failed, " + e.message );
		}
	},*/

}; //var bc_ext


function onContentPopupMenu(event)
{
	bc_ext.showContextMenu(event);
}

window.addEventListener("load", function(e) { bc_ext.onLoad(e); }, false);

